package com.mp3tunes;

import org.xml.sax.*;  
import org.xml.sax.helpers.*;

import java.lang.*;
import java.util.*;
import java.io.*;

public class OboeHandlerList extends org.xml.sax.helpers.DefaultHandler {
    String backref[];
    Map tmap[];
    int p;
    int listCount[];

    OboeHandlerList() {
        backref = new String[16];
        tmap = new Map[16];
        listCount = new int[16];
        p = 0;
    }
    public void startElement(String namespaceURI, String localName,
                             String qualifiedName, Attributes atts) {
        tmap[p] = null;
        backref[p] = localName;
        listCount[p] = 0;

        ++p;
    }

    public void endElement(String namespaceURI, String localName,
                           String qualifiedName) {
        Map temp;
        Object temp2;
        --p;
        if(p != 0 && tmap[p] != null) {
            backref[p] = null;
            if(tmap[p - 1] == null) {
                tmap[p - 1] = new HashMap();
            }
            if(tmap[p].getClass() == (new HashMap()).getClass()) {
                tmap[p].put("tagName", localName);
                tmap[p - 1].put(new Integer(listCount[p - 1]++), tmap[p]);
            }
            else
                tmap[p - 1].put(localName, tmap[p]);

            tmap[p] = null;
        }
    }

    public void characters(char[] ch, int start, int length) {
        if(tmap[p - 1] == null && p != 1) {
            if(tmap[p - 2] == null) {
                tmap[p - 2] = new HashMap();
            }
            if(!tmap[p - 2].containsKey(backref[p - 1])) {
                tmap[p - 2].put(backref[p - 1], (new String(ch)).substring(start, start+length));
            }
        }
    }
}
